alias dem1s {
  var %f = dems.txt, %r2, %r
  var %i = 1, %name, %nt, %data
  var %n = $lines(%f)
  var %j = 1
  ; FIX names to 1 token 32
  clear -s
  while (%i <= %n) {
    %r = $read(%f,%i)
    ; e %r
    %nt = $numtok(%r,32)
    dec %nt 4
    %name = $gettok(%r,1- %nt,32)
    inc %nt
    %data = $gettok(%r,%nt -,32)
    %data = $remove(%data,$chr(9),")
    %name = $remove(%name,$chr(9),')


    %name = $replace(%name,$chr(32),_)
    %name = $lower($remove(%name,_))
    %name = $replace(%name,mountain,mtn)
    e %name %data
    inc %i
  }
  savebuf -s demsformat.txt
  if ($1) .timer.sort 1 1 dems
}
; Sort DEMs text
alias reallyisin {
  var %i = 1, %n = $numtok($2,32)
  while (%i <= %n) {
    if ($1 == $gettok($2,%i,32)) return 1
    inc %i
  }
  return 0
}


; and rename
alias dems_batch {
  var %renf = c:\ftp\dempov\bin\rename_bat.txt
  write -c %renf
  var %wf = c:\ftp\dempov\bin\dem2tga_bat.txt, %d = c:\ftp\dempov\bin
  var %nf = $findfile(%d,*.dem,0,1,e $1)
  var %i
  if (%nf) {
    write -c %wf
    write %wf path $+($chr(37),PATH,$chr(37),$chr(59), %d)
    e %wf path $+($chr(37),PATH,$chr(37),$chr(59), %d)
    %i = 1
    while (%i <= %nf) {
      ffffffff %i
      inc %i
    }
  } 
  else e %nf Digital Elevations Models found
}
alias ffffffff {
  var %renf = c:\ftp\dempov\bin\rename_bat.txt
  var %wf = c:\ftp\dempov\bin\dem2tga_bat.txt, %d = c:\ftp\dempov\bin
  var %i = $1
  var %t, %r, %f = $findfile(%d,*.dem,%i,1)
  if ($fopen(ofile)) .fclose ofile
  .fopen ofile %f

  %r = $left($fread(ofile),940)
  ; e %r
  %r = $gettok(%r,1,44)
  %r = $gettok(%r,1,45)
  %r = $replace(%r,mountain,mtn)
  %r = $remove(%r,$chr(32))
  %r = $remove(%r,')
  %r = $lower(%r)
  .fclose ofile
  %t = %r $+ .tga
  %r = %r $+ .dem
  if ($nopath(%f) != %r) {
    ; e Renaming %f $+($nofile(%f),%r)
    write %renf ren %f %r
    ; $+($nofile(%f),%r)
  }
  write %wf DEMPOV %r %t 0 0 15 0
}

; Digital Elevation Model - sort position
alias dems {
  if (!$window(@sort)) window -dlks @sort $calc($window(-3).w - 540) 10 500 $window(-3).h
  if (!$window(@sort2)) window -dlks @sort2 $calc($window(-3).w - 500) 10 500 $window(-3).h
  var %n = $line(@sort,0)
  dline @sort 1- %n
  %n = $line(@sort2,0)
  dline @sort2 1- %n
  var %f = demsformat.txt
  clear -s
  ; write -c demsort.txt

  var %i = 1, %line, %n2
  %n = $lines(%f)
  var %j = 1, %r, %maxlat = -910000, %minlat = 910000
  while (%i <= %n) {
    %r = $read(%f,%i)
    aline -n @sort $gettok(%r,2-,32) $gettok(%r,1,32)
    inc %i
  }
  %i = 1
  %n = $line(@sort,0)
  var %start = $gettok($line(@sort,1),1,32)
  var %x = 0, %y = 0, %lat, %lon
  while (%i <= %n) {
    %line = $line(@sort,%i)
    %lat = $remove(%line,,')
    if (%minlat > $gettok(%lat,3,32)) %minlat = $gettok(%lat,3,32)
    if (%maxlat < $gettok(%lat,3,32)) %maxlat = $gettok(%lat,3,32)
    if (%start == $gettok(%line,1,32)) {

      aline -n @sort2 $gettok(%line,3-,32) $gettok(%line,1-2,32)
      %lon = $degreeslat($gettok(%line,1,32))
      %y = $int($calc((%lon - 78.5) * 8))
      ;  coco co 110.75
    }
    else {
      %start = %line 
      %j = 1
      %n2 = $line(@sort2,0)
      ; e %n2 same longitude
      while (%j <= %n2) {
        %line = $line(@sort2,%j)
        %lat = $degreeslat($gettok(%line,1,32))
        %x = $int($calc((%lat - 42.998056) * 9))
        ; coco co 34.248333
        ; write 
        ; e demsort.txt $line(@sort2,%j)
        e pce( $+(", $gettok(%line,3,32), .tga") , %x *n, %y *n,0)
        ; inc %x

        inc %j
      }
      dline @sort2 1- %n2
      aline -n @sort2 $gettok(%start,3-,32) $gettok(%start,1-2,32)
      %start = $gettok(%start,1,32)
      ; inc %y
      ; final y increment here, but we wont be back to use it here
    }
    inc %i
  }
  %j = 1
  %x = 0
  %n2 = $line(@sort2,0)
  while (%j <= %n2) {
    %line = $line(@sort2,%j)
    %lat = $degreeslat($gettok(%line,1,32))
    %x = $int($calc((%lat - 42.998056) * 9))
    ; write
    ; e demsort.txt $line(@sort2,%j)
    e pce( $+(", $gettok(%line,3,32), .tga") , %x *n, %y *n,0)
    inc %x
    inc %j
  }
  dline @sort2 1- %n2
  e %minlat %maxlat
  savebuf -s sortpov.txt
  ; saved to $mircdir
}

alias degreeslat {
  var %n = $replace($1,,$chr(32))
  %n = $replace(%n,',$chr(32))
  return $calc($abs($gettok(%n,1,32)) + $gettok(%n,2,32) / 60 + $gettok(%n,3,32) / 60 / 60)
}

alias unzipall {
  var %wf = c:\ftp\dempov\bin\unzip_bat.txt, %d = c:\ftp\dempov\bin
  var %nf = $findfile(%d,*.zip,0,1,e $1)
  var %i
  if (%nf) {
    write -c %wf
    write %wf REM path $+($chr(37),PATH,$chr(37),$chr(59), %d)
    e %wf path $+($chr(37),PATH,$chr(37),$chr(59), %d)
    %i = 1
    while (%i <= %nf) {
      zzzip %i
      inc %i
    }
  }
  ; REM path %PATH%;c:\ftp\dempov\bin
  ; REM 7z x 1627352.zip -u
  ; ren c:\ftp\dempov\bin\*.dem a*
  ; REM 7z a archive.zip c:\ftp\dempov\bin\* -aoa -y -sdel
}

alias zzzip {
  var %wf = c:\ftp\dempov\bin\unzip_bat.txt, %d = c:\ftp\dempov\bin
  var %i = $1
  var %df, %r, %f = $findfile(%d,*.zip,%i,1)
  write %wf 7z x %f
}
alias allDEMcoms {
  ; 30-meter with 7z.exe 7z.dll in folder
  ; example http://www.webgis.com/terr_pages/AZ/dem1/coconino.html
  ; make a dems.txt from html - copy paste to dems.txt
  /dem1s      ... echo Format, remove junk tabs etc. save echo to demsformat.txt

  /dems       ... echo all sorted positions. pce("nelson.tga", 15, 21 ,0)
  ... download the zips ...
  /unzipall   ... make unzip_bat

  unzip_bat   ... same-name files exist! a(u)to rename to keep all. u
  /dems_batch ... make rename_bat
  rename_bat  ... rename DEM files
  /dems_batch ... make dem2tga_bat, with renamed DEM files, for tga files
  dem2tga_bat ... DEMPOV nelson.dem nelson.tga 0 0 15 0

  0 all
  0 or 1 normalize
  15 verticalScale
  [ bias -min_elevation ] optional
  0 ... edge stuff ?
}
